module ErrandBoy
  module Validator
    class SlackInvite < Base
      def check_register_name
        warn 'register_name is empty.' if @request.register['name'].empty?
      rescue NoMethodError
        raise InvalidError, 'register does not set.'
      end

      def check_register_email
        email = @request.register['email']
        if email.empty?
          raise InvalidError, 'register_email is empty.'
        elsif email !~ valid_address
          raise InvalidError, 'register_email is invalid address.'
        end
      rescue NoMethodError
        raise InvalidError, 'register does not set.'
      end

      def check_team
        if @request.destination['team'].empty?
          raise InvalidError, 'team is empty.'
        end
      rescue NoMethodError
        raise InvalidError, 'destination does not set.'
      end
    end
  end
end
